Subject: [manet] OLSR - HNA in IPV6

From: "ying ge" <[email-masked]>
Date: Tue, 13 Apr 2004 15:31:38 -0400

Dear group,

We are implementing OLSR_RFC with IPV6. According to the RFC, although the
proposed message format is based on IPV4, we can use IPV6 address to replace
the IPV4 address. This strategy does not have any problem for HELLO, TC and
MID packets. However, for HNA packet, the packet format in IPV4 is as
following:
0  1  2  3  4  5  6  7  8 9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5
6  7  8  9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                          Network Address
|
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               Netmask
|
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                          Network Address
|
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               Netmask
|
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                              ........
|
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

My question : How can we change it to IPV6 format, as IPV6 does not have
"network mask""? Our proposed HNA format for IPV6 is as following, what do
you think about it?

0  1  2  3  4  5  6  7  8 9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5
6  7  8  9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                          Network Address
|
|                                                                in
|
|                                                            IPV6
|
|                                                        (128 bits)
|
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|            Network prefix (16 bits)            |            Reserved
|
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                          Network Address
|
|                                                                in
|
|                                                            IPV6
|
|                                                        (128 bits)
|
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|            Network prefix (16 bits)            |            Reserved
|
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                              ........
|
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Thanks a lot for your comment

Ying Ge
communications Canada
3701 Carling Ave. | 3701, avenue Carling
PO Box 11490, Station H | CP 11490, succursale H
Ottawa ON K2H 8S2 | Ottawa (Ontario) K2H 8S2
(613) 998-2819 | [email-masked] |
Web site / Site web : www.crc.ca
Government of Canada | Gouvernement du Canada

_______________________________________________
manet mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/manet

---

From: Cedric Adjih <[email-masked]>
Date: Wed, 14 Apr 2004 10:51:49 +0200

Hello Ying,

Indeed, the packet format for HNA with IPv6 is not optimized.
Still, in IPv6, you can translate the network prefix length as
a netmask [of course as something like (1<<128)-(1<<(128-N))],
so my interpretation is that an IPv6 RFC-compliant implementation
must do that. 
Of course, now, maybe you would like to throw received netmasks 
which are not proper prefixes.

Regards,
-- Cedric

On Tuesday 13 April 2004 21:31, ying ge wrote:
> proposed message format is based on IPV4, we can use IPV6 address to
> replace the IPV4 address. This strategy does not have any problem for
> HELLO, TC and MID packets. However, for HNA packet, the packet format in
> IPV4 is as following:

---

From: Andreas Tønnesen <[email-masked]>
Date: Wed, 14 Apr 2004 11:10:53 +0200

Hi,

In the UniK OLSR implementation I've chosen to just transmit the prefix 
length when using IPv6. It would might be easier if HNA packets 
contained a 16 bit prefix length for both IPv4 and IPv6?

regards,
Andreas T

-- 

-- 
Andreas Tønnesen([email-masked])
UniK University Graduation Center
University of Oslo
http://www.olsr.org

---

From: Cedric Adjih <[email-masked]>
Date: Wed, 14 Apr 2004 11:37:45 +0200

Hello Andreas,

> contained a 16 bit prefix length for both IPv4 and IPv6?

Hmm... Easier, yes ; compliant, no :-)
I would have prefered prefix length too for the final RFC, but it was not
done that way, and moreover it was not important at all.
This a very small issue, and the RFC isn't going to be changed overnight,
so it's better to go for the netmask.

Regards,
-- Cedric

> >>We are implementing OLSR_RFC with IPV6. According to the RFC, although
> >> the proposed message format is based on IPV4, we can use IPV6 address to
> >>[... snip ...]

---

From: Andreas Tønnesen <[email-masked]>
Date: Thu, 15 Apr 2004 16:28:52 +0200

ying ge wrote:

> To Andreas:
> Is such design same as that in your implementation?
> 

I use excatly that design. I was aware that it was breaking
compability but I never bothered fixing it. I will however
update it in the next release for the sake of compliance.

It'll just be some extra bits frying my brain here at the
lab ;)

regards,
Andreas

> 
> Best regards
> 
> Ying
> ----- Original Message ----- 
> From: "Cedric Adjih" <[email-masked]>
> To: <[email-masked]>
> Cc: "ying ge" <[email-masked]>
> Sent: Wednesday, April 14, 2004 4:51 AM
> Subject: Re: [manet] OLSR - HNA in IPV6
> 
> 
> 
>>Hello Ying,
>>
> the
>>>0  1  2  3  4  5  6  7  8 9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4
> 
> 5
> 
>>>6  7  8  9 0 1
>>>|                                                          Network
> Address
>>>|                                                          Network
> Address
>>>"network mask""? Our proposed HNA format for IPV6 is as following, what
> 
> do
> 
>>>you think about it?
>>>
>>>0  1  2  3  4  5  6  7  8 9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4
> 
> 5
> 
>>>6  7  8  9 0 1
>>>|                                                          Network
> Address
>>>|                                                          Network
> Address
>> ------------------------------------------------------------------------
>>

--